Index: c/src/exec/score/cpu/i386/cpu.c
===================================================================
--- c/src/exec/score/cpu/i386/cpu.c	(revision 73452854c06c49caad04b92064e0c1fb40cca02a)
+++ c/src/exec/score/cpu/i386/cpu.c	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -77,101 +77,2 @@
 }
  
-/*PAGE
- *
- *  _CPU_ISR_install_raw_handler
- */
- 
-#if __GO32__
-#include <go32.h>
-#include <dpmi.h>
-#endif /* __GO32__ */
-
-void _CPU_ISR_install_raw_handler(
-  unsigned32  vector,
-  proc_ptr    new_handler,
-  proc_ptr   *old_handler
-)
-{
-#if __GO32__
-    _go32_dpmi_seginfo handler_info;
- 
-    /* get the address of the old handler */
-    _go32_dpmi_get_protected_mode_interrupt_vector( vector, &handler_info);
- 
-    /* Notice how we're failing to save the pm_segment portion of the */
-    /* structure here?  That means we might crash the system if we  */
-    /* try to restore the ISR.  Can't fix this until i386_isr is  */
-    /* redefined.  XXX [BHC].           */
-    *old_handler = (proc_ptr *) handler_info.pm_offset;
-
-    handler_info.pm_offset = (u_long) new_handler;
-    handler_info.pm_selector = _go32_my_cs();
-
-    /* install the IDT entry */
-    _go32_dpmi_set_protected_mode_interrupt_vector( vector, &handler_info );
-#else
-  i386_IDT_slot idt;
-  unsigned32    handler;
-
-  *old_handler =  0;    /* XXX not supported */
-
-  handler = (unsigned32) new_handler;
-
-  /* build the IDT entry */
-  idt.offset_0_15      = handler & 0xffff;
-  idt.segment_selector = i386_get_cs();
-  idt.reserved         = 0x00;
-  idt.p_dpl            = 0x8e;         /* present, ISR */
-  idt.offset_16_31     = handler >> 16;
-
-  /* install the IDT entry */
-  i386_Install_idt(
-    (unsigned32) &idt,
-    _CPU_Table.interrupt_table_segment,
-    (unsigned32) _CPU_Table.interrupt_table_offset + (8 * vector)
-  );
-#endif
-}
-
-/*PAGE
- *
- *  _CPU_ISR_install_vector
- *
- *  This kernel routine installs the RTEMS handler for the
- *  specified vector.
- *
- *  Input parameters:
- *    vector      - interrupt vector number
- *    old_handler - former ISR for this vector number
- *    new_handler - replacement ISR for this vector number
- *
- *  Output parameters:  NONE
- *
- */
-
-void _ISR_Handler_0(), _ISR_Handler_1();
-
-#define PER_ISR_ENTRY \
-    (((unsigned32) _ISR_Handler_1 - (unsigned32) _ISR_Handler_0))
-
-#define _Interrupt_Handler_entry( _vector ) \
-   (((unsigned32)_ISR_Handler_0) + ((_vector) * PER_ISR_ENTRY))
-
-void _CPU_ISR_install_vector(
-  unsigned32  vector,
-  proc_ptr    new_handler,
-  proc_ptr   *old_handler
-)
-{
-  proc_ptr      ignored;
-  unsigned32    unique_handler;
-
-  *old_handler = _ISR_Vector_table[ vector ];
-
-  /* calculate the unique entry point for this vector */
-  unique_handler = _Interrupt_Handler_entry( vector );
-
-  _CPU_ISR_install_raw_handler( vector, (void *)unique_handler, &ignored );
-
-  _ISR_Vector_table[ vector ] = new_handler;
-}
Index: c/src/exec/score/cpu/i386/cpu.h
===================================================================
--- c/src/exec/score/cpu/i386/cpu.h	(revision 73452854c06c49caad04b92064e0c1fb40cca02a)
+++ c/src/exec/score/cpu/i386/cpu.h	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -23,4 +23,6 @@
 
 #include <rtems/score/i386.h>              /* pick up machine definitions */
+#include <libcpu/cpu.h>
+
 #ifndef ASM
 #include <rtems/score/i386types.h>
Index: c/src/exec/score/cpu/i386/cpu_asm.s
===================================================================
--- c/src/exec/score/cpu/i386/cpu_asm.s	(revision 73452854c06c49caad04b92064e0c1fb40cca02a)
+++ c/src/exec/score/cpu/i386/cpu_asm.s	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -553,44 +553,4 @@
 
 #ifndef __GO32__
-/*PAGE
- *
- *  void i386_Install_idt(
- *    unsigned32 source_offset,
- *    unsigned16 destination_segment,
- *    unsigned32 destination_offset
- *  );
- */
-
-        .p2align  2
-        PUBLIC (i386_Install_idt)
-
-.set INSTALL_IDT_SAVED_REGS,   8
-
-.set SOURCE_OFFSET_ARG,        INSTALL_IDT_SAVED_REGS + 4
-.set DESTINATION_SEGMENT_ARG,  INSTALL_IDT_SAVED_REGS + 8
-.set DESTINATION_OFFSET_ARG,   INSTALL_IDT_SAVED_REGS + 12
-
-SYM (i386_Install_idt):
-        push      esi
-        push      edi
-
-        movl      SOURCE_OFFSET_ARG(esp),esi
-        movl      DESTINATION_OFFSET_ARG(esp),edi
-
-        pushf                                  # save flags
-        cli                                    # DISABLE INTERRUPTS!!!
-
-        movw      DESTINATION_SEGMENT_ARG+4(esp),ax
-        push      es                           # save es
-        movw      ax,es
-        movsl                                  # copy 1st half of IDT entry
-        movsl                                  # copy 2nd half of IDT entry
-        pop       es                           # restore es
-
-        popf                                   # ENABLE INTERRUPTS!!!
-
-        pop       edi
-        pop       esi
-        ret
 
 /*
Index: c/src/exec/score/cpu/i386/i386.h
===================================================================
--- c/src/exec/score/cpu/i386/i386.h	(revision 73452854c06c49caad04b92064e0c1fb40cca02a)
+++ c/src/exec/score/cpu/i386/i386.h	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -100,80 +100,4 @@
 
 /*
- *  Structure which makes it easier to deal with LxDT and SxDT instructions.
- */
- 
-typedef struct {
-  unsigned short limit;
-  unsigned short physical_address[ 2 ];
-} i386_DTR_load_save_format;
- 
-/* See Chapter 5 - Memory Management in i386 manual */
- 
-typedef struct {
-  unsigned short limit_0_15;
-  unsigned short base_0_15;
-  unsigned char  base_16_23;
-  unsigned char  type_dt_dpl_p;
-  unsigned char  limit_16_19_granularity;
-  unsigned char  base_24_31;
-}   i386_GDT_slot;
- 
-/* See Chapter 9 - Exceptions and Interrupts in i386 manual
- *
- *  NOTE: This is the IDT entry for interrupt gates ONLY.
- */
- 
-typedef struct {
-  unsigned short offset_0_15;
-  unsigned short segment_selector;
-  unsigned char  reserved;
-  unsigned char  p_dpl;
-  unsigned short offset_16_31;
-}   i386_IDT_slot;
-
-/*
- *  Interrupt Level Macros
- */
-
-#define i386_disable_interrupts( _level ) \
-  { \
-    _level = 0;   /* avoids warnings */ \
-    asm volatile ( "pushf ; \
-                    cli ; \
-                    pop %0" \
-                    : "=r" ((_level)) : "0" ((_level)) \
-    ); \
-  }
-
-#define i386_enable_interrupts( _level )  \
-  { \
-    asm volatile ( "push %0 ; \
-                    popf" \
-                    : "=r" ((_level)) : "0" ((_level)) \
-    ); \
-  }
-
-#define i386_flash_interrupts( _level ) \
-  { \
-    asm volatile ( "push %0 ; \
-                    popf ; \
-                    cli" \
-                    : "=r" ((_level)) : "0" ((_level)) \
-    ); \
-  }
-
-#define i386_get_interrupt_level( _level ) \
-  do { \
-    register unsigned32 _eflags = 0; \
-    \
-    asm volatile ( "pushf ; \
-                    pop %0" \
-                    : "=r" ((_eflags)) : "0" ((_eflags)) \
-    ); \
-    \
-    _level = (_eflags & 0x0200) ? 0 : 1; \
-  } while (0)
-
-/*
  *  The following routine swaps the endian format of an unsigned int.
  *  It must be static so it can be referenced indirectly.
@@ -207,65 +131,4 @@
 
 /*
- *  Segment Access Routines
- *
- *  NOTE:  Unfortunately, these are still static inlines even when the
- *         "macro" implementation of the generic code is used.
- */
-
-static inline unsigned short i386_get_cs()
-{
-  register unsigned short segment = 0;
-
-  asm volatile ( "movw %%cs,%0" : "=r" (segment) : "0" (segment) );
-
-  return segment;
-}
-
-static inline unsigned short i386_get_ds()
-{
-  register unsigned short segment = 0;
-
-  asm volatile ( "movw %%ds,%0" : "=r" (segment) : "0" (segment) );
-
-  return segment;
-}
-
-static inline unsigned short i386_get_es()
-{
-  register unsigned short segment = 0;
-
-  asm volatile ( "movw %%es,%0" : "=r" (segment) : "0" (segment) );
-
-  return segment;
-}
-
-static inline unsigned short i386_get_ss()
-{
-  register unsigned short segment = 0;
-
-  asm volatile ( "movw %%ss,%0" : "=r" (segment) : "0" (segment) );
-
-  return segment;
-}
-
-static inline unsigned short i386_get_fs()
-{
-  register unsigned short segment = 0;
-
-  asm volatile ( "movw %%fs,%0" : "=r" (segment) : "0" (segment) );
-
-  return segment;
-}
-
-static inline unsigned short i386_get_gs()
-{
-  register unsigned short segment = 0;
-
-  asm volatile ( "movw %%gs,%0" : "=r" (segment) : "0" (segment) );
-
-  return segment;
-}
-
-/*
  *  IO Port Access Routines
  */
@@ -328,99 +191,4 @@
    }
 
-/*
- *  Descriptor Table helper routines
- */
-
-
-#define i386_get_GDTR( _gdtr_address ) \
-  { \
-    void *_gdtr = (_gdtr_address); \
-    \
-    asm volatile( "sgdt   (%0)" : "=r" (_gdtr) : "0" (_gdtr) ); \
-  }
-
-#define i386_get_GDT_slot( _gdtr_base, _segment, _slot_address ) \
-  { \
-    register unsigned int   _gdt_slot  = (_gdtr_base) + (_segment); \
-    register volatile void *_slot      = (_slot_address); \
-    register unsigned int   _temporary = 0; \
-    \
-    asm volatile( "movl %%gs:(%0),%1 ; \
-                   movl %1,(%2) ; \
-                   movl %%gs:4(%0),%1 ; \
-                   movl %1,4(%2)"  \
-                     : "=r" (_gdt_slot), "=r" (_temporary), "=r" (_slot) \
-                     : "0"  (_gdt_slot), "1"  (_temporary), "2"  (_slot) \
-                );  \
-  }
-
-#define i386_set_GDT_slot( _gdtr_base, _segment, _slot_address ) \
-  { \
-    register unsigned int   _gdt_slot  = (_gdtr_base) + (_segment); \
-    register volatile void *_slot      = (_slot_address); \
-    register unsigned int   _temporary = 0; \
-    \
-    asm volatile( "movl (%2),%1 ; \
-                   movl %1,%%gs:(%0) ; \
-                   movl 4(%2),%1 ; \
-                   movl %1,%%gs:4(%0) \
-                  " \
-                     : "=r" (_gdt_slot), "=r" (_temporary), "=r" (_slot) \
-                     : "0"  (_gdt_slot), "1"  (_temporary), "2"  (_slot) \
-                );  \
-  }
-
-static inline void i386_set_segment(
-  unsigned short segment,
-  unsigned int  base,
-  unsigned int  limit
-)
-{
-  i386_DTR_load_save_format         gdtr;
-  volatile i386_GDT_slot            Gdt_slot;
-  volatile i386_GDT_slot           *gdt_slot = &Gdt_slot;
-  unsigned short                    tmp_segment = 0;
-  unsigned int                      limit_adjusted;
-
-  /* load physical address of the GDT */
-
-  i386_get_GDTR( &gdtr );
-
-  gdt_slot->type_dt_dpl_p  = 0x92;             /* present, dpl=0,      */
-                                               /* application=1,       */
-                                               /* type=data read/write */
-  gdt_slot->limit_16_19_granularity = 0x40;    /* 32 bit segment       */
-
-  limit_adjusted = limit;
-  if ( limit > 4095 ) {
-    gdt_slot->limit_16_19_granularity |= 0x80; /* set granularity bit */
-    limit_adjusted /= 4096;
-  }
-
-  gdt_slot->limit_16_19_granularity |= (limit_adjusted >> 16) & 0xff;
-  gdt_slot->limit_0_15               = limit_adjusted & 0xffff;
-
-  gdt_slot->base_0_15  = base & 0xffff;
-  gdt_slot->base_16_23 = (base >> 16) & 0xff;
-  gdt_slot->base_24_31 = (base >> 24);
-
-  i386_set_GDT_slot(
-    gdtr.physical_address[0] + (gdtr.physical_address[1] << 16),
-    segment,
-    gdt_slot
-  );
-
-  /* Now, reload all segment registers so the limit takes effect. */
-
-  asm volatile( "movw %%ds,%0 ; movw %0,%%ds
-                 movw %%es,%0 ; movw %0,%%es
-                 movw %%fs,%0 ; movw %0,%%fs
-                 movw %%gs,%0 ; movw %0,%%gs
-                 movw %%ss,%0 ; movw %0,%%ss"
-                   : "=r" (tmp_segment)
-                   : "0"  (tmp_segment)
-              );
-
-}
 
 /* routines */
@@ -448,15 +216,4 @@
 );
 
-/*
- *  i386_Install_idt
- *
- *  This routine installs an IDT entry.
- */
-
-void i386_Install_idt(
-  unsigned int   source_offset,
-  unsigned short destination_segment,
-  unsigned int   destination_offset
-);
 
 /*
@@ -485,18 +242,4 @@
 #define inport_long( _port, _value )  i386_inport_long( _port, _value )
  
-/* complicated static inline functions */
- 
-#define get_GDTR( _gdtr_address ) \
-        i386_get_GDTR( _gdtr_address )
- 
-#define get_GDT_slot( _gdtr_base, _segment, _slot_address ) \
-        i386_get_GDT_slot( _gdtr_base, _segment, _slot_address )
- 
-#define set_GDT_slot( _gdtr_base, _segment, _slot_address ) \
-        i386_set_GDT_slot( _gdtr_base, _segment, _slot_address )
- 
-#define set_segment( _segment, _base, _limit ) \
-  i386_set_segment( _segment, _base, _limit )
- 
 
 #ifdef __cplusplus
Index: c/src/lib/libbsp/i386/pc386/clock/ckinit.c
===================================================================
--- c/src/lib/libbsp/i386/pc386/clock/ckinit.c	(revision 73452854c06c49caad04b92064e0c1fb40cca02a)
+++ c/src/lib/libbsp/i386/pc386/clock/ckinit.c	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -40,9 +40,4 @@
 
 /*-------------------------------------------------------------------------+
-| Constants
-+--------------------------------------------------------------------------*/
-#define CLOCK_IRQ  0x00  /* Clock IRQ. */
-
-/*-------------------------------------------------------------------------+
 | Macros
 +--------------------------------------------------------------------------*/
@@ -68,11 +63,10 @@
 /*-------------------------------------------------------------------------+
 |         Function: clockIsr
-|      Description: Interrupt Service Routine for clock (08h) interruption.
+|      Description: Interrupt Service Routine for clock (0h) interruption.
 | Global Variables: Clock_driver_ticks, Clock_isrs.
 |        Arguments: vector - standard RTEMS argument - see documentation.
 |          Returns: standard return value - see documentation. 
 +--------------------------------------------------------------------------*/
-static rtems_isr
-clockIsr(rtems_vector_number vector)
+static void clockIsr()
 {
   /*-------------------------------------------------------------------------+
@@ -99,7 +93,5 @@
     Clock_isrs--;
 
-  PC386_ackIrq(vector - PC386_IRQ_VECTOR_BASE);
 } /* clockIsr */
-
 
 /*-------------------------------------------------------------------------+
@@ -111,5 +103,5 @@
 |          Returns: Nothing. 
 +--------------------------------------------------------------------------*/
-void Clock_exit(void)
+void clockOff(const rtems_irq_connect_data* unused)
 {
   if (BSP_Configuration.ticks_per_timeslice)
@@ -130,11 +122,8 @@
 |          Returns: Nothing. 
 +--------------------------------------------------------------------------*/
-void
-Install_clock(rtems_isr_entry isr)
+static void clockOn(const rtems_irq_connect_data* unused)
 {
   rtems_unsigned32  microseconds_per_isr;
 
-  rtems_status_code status;
- 
 #if 0
   /* Initialize clock from on-board real time clock.  This breaks the  */
@@ -176,12 +165,4 @@
     rtems_unsigned32 count = US_TO_TICK(microseconds_per_isr);
 
-    status = PC386_installRtemsIrqHandler(CLOCK_IRQ, isr);
-
-    if (status != RTEMS_SUCCESSFUL)
-    {
-      printk("Error installing clock interrupt handler!\n");
-      rtems_fatal_error_occurred(status);
-    }
-
     outport_byte(TIMER_MODE, TIMER_SEL0|TIMER_16BIT|TIMER_RATEGEN);
     outport_byte(TIMER_CNTR0, count >> 0 & 0xff);
@@ -189,7 +170,18 @@
   } 
 
-  atexit(Clock_exit);
-} /* Install_clock */
-
+} 
+
+int clockIsOn(const rtems_irq_connect_data* unused)
+{
+  return ((i8259s_cache & 0x1) == 0);
+}
+
+static rtems_irq_connect_data clockIrqData = {PC_386_PERIODIC_TIMER,
+					      clockIsr,
+					      clockOn,
+					      clockOff,
+					      clockIsOn};
+					      
+					      
 
 /*-------------------------------------------------------------------------+
@@ -203,6 +195,9 @@
                  void                      *pargp)
 {
-  Install_clock(clockIsr); /* Install the interrupt handler */
- 
+
+  if (!pc386_install_rtems_irq_handler (&clockIrqData)) {
+    printk("Unable to initialize system clock\n");
+    rtems_fatal_error_occurred(1);
+  }
   /* make major/minor avail to others such as shared memory driver */
  
@@ -213,5 +208,5 @@
 } /* Clock_initialize */
 
-
+					      
 /*-------------------------------------------------------------------------+
 | Console device driver CONTROL entry point
@@ -232,15 +227,10 @@
  
     if      (args->command == rtems_build_name('I', 'S', 'R', ' '))
-      clockIsr(PC386_IRQ_VECTOR_BASE + CLOCK_IRQ);
+      clockIsr();
     else if (args->command == rtems_build_name('N', 'E', 'W', ' '))
     {
-      rtems_status_code status;
-      
-      status = PC386_installRtemsIrqHandler(CLOCK_IRQ, clockIsr);
-
-      if (status != RTEMS_SUCCESSFUL)
-      {
+      if (!pc386_install_rtems_irq_handler (&clockIrqData)) {
 	printk("Error installing clock interrupt handler!\n");
-	rtems_fatal_error_occurred(status);
+	rtems_fatal_error_occurred(1);
       }
     }
@@ -250,4 +240,8 @@
 } /* Clock_control */
 
+void Clock_exit()
+{
+  pc386_remove_rtems_irq_handler (&clockIrqData);
+}
 
 /*-------------------------------------------------------------------------+
Index: c/src/lib/libbsp/i386/pc386/console/console.c
===================================================================
--- c/src/lib/libbsp/i386/pc386/console/console.c	(revision 73452854c06c49caad04b92064e0c1fb40cca02a)
+++ c/src/lib/libbsp/i386/pc386/console/console.c	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -47,14 +47,17 @@
 
 /*-------------------------------------------------------------------------+
-| Constants
-+--------------------------------------------------------------------------*/
-#define KEYBOARD_IRQ  0x01  /* Keyboard IRQ. */
-
-
-/*-------------------------------------------------------------------------+
 | External Prototypes
 +--------------------------------------------------------------------------*/
-extern rtems_isr _IBMPC_keyboard_isr(rtems_vector_number);
-       /* keyboard (IRQ 0x01) Interrupt Service Routine (defined in 'inch.c') */
+extern void 	_IBMPC_keyboard_isr(void);
+extern void 	_IBMPC_keyboard_isr_on(const rtems_irq_connect_data*);
+extern void 	_IBMPC_keyboard_isr_off(const rtems_irq_connect_data*);
+extern int 	_IBMPC_keyboard_isr_is_on(const rtems_irq_connect_data*);
+
+static rtems_irq_connect_data console_isr_data = {PC_386_KEYBOARD,
+						   _IBMPC_keyboard_isr,
+						   _IBMPC_keyboard_isr_on,
+						   _IBMPC_keyboard_isr_off,
+						   _IBMPC_keyboard_isr_is_on};
+						   
 
 extern rtems_boolean _IBMPC_scankey(char *);  /* defined in 'inch.c' */
@@ -165,7 +168,7 @@
 
       /* Install keyboard interrupt handler */
-      status = PC386_installRtemsIrqHandler(KEYBOARD_IRQ, _IBMPC_keyboard_isr);
-
-      if (status != RTEMS_SUCCESSFUL)
+  status = pc386_install_rtems_irq_handler(&console_isr_data);
+  
+  if (!status)
 	{
 	  printk("Error installing keyboard interrupt handler!\n");
@@ -199,14 +202,16 @@
       if(PC386ConsolePort == PC386_UART_COM1)
 	{
-	  status = PC386_installRtemsIrqHandler(PC386_UART_COM1_IRQ,
-						PC386_uart_termios_isr_com1);
+	  console_isr_data.name = PC386_UART_COM1_IRQ;
+	  console_isr_data.hdl  = PC386_uart_termios_isr_com1;
+	  
 	}
       else
 	{
           assert(PC386ConsolePort == PC386_UART_COM2);
-
-	  status = PC386_installRtemsIrqHandler(PC386_UART_COM2_IRQ,
-						PC386_uart_termios_isr_com2);
-	}
+	  console_isr_data.name = PC386_UART_COM2_IRQ;
+	  console_isr_data.hdl  = PC386_uart_termios_isr_com2;
+	}
+
+      status =pc386_install_rtems_irq_handler(&console_isr_data);
       /*
        * Register the device
@@ -292,10 +297,13 @@
               void                      *arg)
 {
+  rtems_device_driver res = RTEMS_SUCCESSFUL;
+  
   if(PC386ConsolePort != PC386_CONSOLE_PORT_CONSOLE)
     {
-      return rtems_termios_close (arg);
-    }
-
-  return RTEMS_SUCCESSFUL;
+      res =  rtems_termios_close (arg);
+    }
+  pc386_remove_rtems_irq_handler (&console_isr_data);
+  
+  return res;
 } /* console_close */
 
Index: c/src/lib/libbsp/i386/pc386/console/inch.c
===================================================================
--- c/src/lib/libbsp/i386/pc386/console/inch.c	(revision 73452854c06c49caad04b92064e0c1fb40cca02a)
+++ c/src/lib/libbsp/i386/pc386/console/inch.c	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -211,4 +211,15 @@
 } /* _IBMPC_scankey */
 
+void _IBMPC_keyboard_isr_on(const rtems_irq_connect_data* unused)
+{}
+void _IBMPC_keyboard_isr_off(const rtems_irq_connect_data* unused)
+{}
+
+int _IBMPC_keyboard_isr_is_on(const rtems_irq_connect_data* irq)
+{
+  return pc386_irq_enabled_at_i8259s (irq->name);
+}
+
+
 
 /*-------------------------------------------------------------------------+
@@ -219,6 +230,5 @@
 |          Returns: standard return value - see documentation.
 +--------------------------------------------------------------------------*/
-rtems_isr
-_IBMPC_keyboard_isr(rtems_vector_number vector)
+void _IBMPC_keyboard_isr()
 {
   if (_IBMPC_scankey(&kbd_buffer[kbd_last]))
@@ -232,6 +242,4 @@
       }
   }
-
-  PC386_ackIrq(vector - PC386_IRQ_VECTOR_BASE); /* Mark interrupt as handled. */
 } /* _IBMPC_keyboard_isr */
 
@@ -281,4 +289,19 @@
     return c;
 } /* _IBMPC_inch */
+
+ 
+ /*
+  * Routine that can be used before interrupt management is initialized.
+  */
+ 
+char
+debugPollingGetChar(void)
+{
+  char c;
+  while (!_IBMPC_scankey(&c))
+    continue;
+
+  return c;
+}
 
 /*-------------------------------------------------------------------------+
Index: c/src/lib/libbsp/i386/pc386/include/bsp.h
===================================================================
--- c/src/lib/libbsp/i386/pc386/include/bsp.h	(revision 73452854c06c49caad04b92064e0c1fb40cca02a)
+++ c/src/lib/libbsp/i386/pc386/include/bsp.h	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -52,5 +52,6 @@
 #include <console.h>
 #include <clockdrv.h>
-
+#include <libcpu/cpu.h>
+  
 /*-------------------------------------------------------------------------+
 | Constants
@@ -134,6 +135,9 @@
 | External Variables.
 +--------------------------------------------------------------------------*/
-extern i386_IDT_slot Interrupt_descriptor_table[];
-extern i386_GDT_slot Global_descriptor_table   [];
+#define IDT_SIZE 256
+#define GDT_SIZE 3
+
+extern interrupt_gate_descriptor Interrupt_descriptor_table[IDT_SIZE];
+extern segment_descriptors Global_descriptor_table   [GDT_SIZE];
  
 extern rtems_configuration_table BSP_Configuration;
Index: c/src/lib/libbsp/i386/pc386/start/start.s
===================================================================
--- c/src/lib/libbsp/i386/pc386/start/start.s	(revision 73452854c06c49caad04b92064e0c1fb40cca02a)
+++ c/src/lib/libbsp/i386/pc386/start/start.s	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -105,5 +105,6 @@
 	addl	$4, esp
 
-	/*call	debugPollingGetChar */
+	call	debugPollingGetChar
+	
 #endif	
 
Index: c/src/lib/libbsp/i386/pc386/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/i386/pc386/startup/bspstart.c	(revision 73452854c06c49caad04b92064e0c1fb40cca02a)
+++ c/src/lib/libbsp/i386/pc386/startup/bspstart.c	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -66,5 +66,6 @@
 void bsp_libc_init( void *, unsigned32, int );
 void bsp_postdriver_hook(void);
- 
+extern void rtems_irq_mngt_init();
+
 /*-------------------------------------------------------------------------+
 |         Function: bsp_pretasking_hook
@@ -130,4 +131,9 @@
 
   /*
+   * Init trems_interrupt_management
+   */
+  rtems_irq_mngt_init();
+  
+  /*
    *  The following information is very useful when debugging.
    */
Index: c/src/lib/libbsp/i386/pc386/startup/ldsegs.s
===================================================================
--- c/src/lib/libbsp/i386/pc386/startup/ldsegs.s	(revision 73452854c06c49caad04b92064e0c1fb40cca02a)
+++ c/src/lib/libbsp/i386/pc386/startup/ldsegs.s	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -46,10 +46,11 @@
 | CODE section
 +----------------------------------------------------------------------------*/
-
+EXTERN (rtems_i8259_masks)
+	
 BEGIN_CODE
 
         EXTERN (_establish_stack)
 	EXTERN (Timer_exit)
-	EXTERN (Clock_exit)
+	EXTERN (clockOff)
 
 	.p2align 4
@@ -96,23 +97,4 @@
 	movw ax, gs
 
-	/* Set default interrupt handler */
-	movl  $0, ecx
-	movl  $Interrupt_descriptor_table, eax
-	movl  $_default_int_handler, ebx
-	movl  ebx, edx
-	sarl  $16, edx
-loop:
-	movw  bx, (eax)
-	movw  $0x8, 2(eax)
-	movw  $0x8e00, 4(eax)
-	movw  dx, 8(eax)
-	addl  $8, eax
-	addl  $1, ecx
-	cmpl  $255, ecx
-	jle   loop
-	
-	
-	
-
 /*---------------------------------------------------------------------+
 | Now we have to reprogram the interrupts :-(. We put them right after
@@ -158,4 +140,6 @@
 	call	SYM(delay)
 
+	movw	$0xFFFB, SYM(i8259s_cache) /* set up same values in cache */
+	
 	jmp	SYM (_establish_stack)	# return to the bsp entry code
 
@@ -186,8 +170,4 @@
 	.p2align 4
 	
-	PUBLIC (_default_int_handler)
-SYM (_default_int_handler):
-	iret
-
 /*---------------------------------------------------------------------------+
 | GDT itself
Index: c/src/lib/libbsp/i386/pc386/timer/timer.c
===================================================================
--- c/src/lib/libbsp/i386/pc386/timer/timer.c	(revision 73452854c06c49caad04b92064e0c1fb40cca02a)
+++ c/src/lib/libbsp/i386/pc386/timer/timer.c	(revision 67a2288991ce3662a588ee83c0bea9c9efae5f1e)
@@ -44,5 +44,4 @@
 | Constants
 +--------------------------------------------------------------------------*/
-#define TIMER_IRQ     0x00           /* Timer IRQ.                            */
 #define AVG_OVERHEAD  0              /* 0.1 microseconds to start/stop timer. */
 #define LEAST_VALID   1              /* Don't trust a value lower than this.  */
@@ -53,4 +52,11 @@
 volatile rtems_unsigned32 Ttimer_val;
          rtems_boolean    Timer_driver_Find_average_overhead = TRUE;
+
+/*-------------------------------------------------------------------------+
+| External Prototypes
++--------------------------------------------------------------------------*/
+extern void timerisr();
+       /* timer (int 08h) Interrupt Service Routine (defined in 'timerisr.s') */
+extern int clockIsOn(const rtems_irq_connect_data*);
 
 /*-------------------------------------------------------------------------+
@@ -87,5 +93,4 @@
 Timer_exit(void)
 {
-  PC386_disableIrq(TIMER_IRQ);
 } /* Timer_exit */
 
@@ -108,6 +113,4 @@
 
     atexit(Timer_exit); /* Try not to hose the system at exit. */
-    PC386_enableIrq(TIMER_IRQ);
-                  /* Disable the programmable timer so ticks don't interfere. */
   }
   Ttimer_val = rdtsc(); /* read starting time */
@@ -144,9 +147,4 @@
 #define US_PER_ISR   250  /* Number of micro-seconds per timer interruption */
 
-/*-------------------------------------------------------------------------+
-| External Prototypes
-+--------------------------------------------------------------------------*/
-extern rtems_isr timerisr(rtems_vector_number);
-       /* timer (int 08h) Interrupt Service Routine (defined in 'timerisr.s') */
 
 /*-------------------------------------------------------------------------+
@@ -159,12 +157,50 @@
 +--------------------------------------------------------------------------*/
 void
+timerOff(const rtems_raw_irq_connect_data* used)
+{
+    /*
+     * disable interrrupt at i8259 level
+     */
+     pc386_irq_disable_at_i8259s(used->idtIndex - PC386_IRQ_VECTOR_BASE);
+     /* reset timer mode to standard (DOS) value */
+     outport_byte(TIMER_MODE, TIMER_SEL0|TIMER_16BIT|TIMER_RATEGEN);
+     outport_byte(TIMER_CNTR0, 0);
+     outport_byte(TIMER_CNTR0, 0);
+} /* Timer_exit */
+
+
+void timerOn(const rtems_raw_irq_connect_data* used)
+{
+     /* load timer for US_PER_ISR microsecond period */
+     outport_byte(TIMER_MODE, TIMER_SEL0|TIMER_16BIT|TIMER_RATEGEN);
+     outport_byte(TIMER_CNTR0, US_TO_TICK(US_PER_ISR) >> 0 & 0xff);
+     outport_byte(TIMER_CNTR0, US_TO_TICK(US_PER_ISR) >> 8 & 0xff);
+    /*
+     * disable interrrupt at i8259 level
+     */
+     pc386_irq_enable_at_i8259s(used->idtIndex - PC386_IRQ_VECTOR_BASE);
+}
+
+static rtems_raw_irq_connect_data timer_raw_irq_data = {
+  PC_386_PERIODIC_TIMER + PC386_IRQ_VECTOR_BASE,
+  timerisr,
+  timerOn,
+  timerOff,
+  clockIsOn
+};
+
+/*-------------------------------------------------------------------------+
+|         Function: Timer_exit
+|      Description: Timer cleanup routine at RTEMS exit. NOTE: This routine is
+|                   not really necessary, since there will be a reset at exit.
+| Global Variables: None.
+|        Arguments: None.
+|          Returns: Nothing. 
++--------------------------------------------------------------------------*/
+void
 Timer_exit(void)
 {
-  /* reset timer mode to standard (DOS) value */
-  outport_byte(TIMER_MODE, TIMER_SEL0|TIMER_16BIT|TIMER_RATEGEN);
-  outport_byte(TIMER_CNTR0, 0);
-  outport_byte(TIMER_CNTR0, 0);
+  i386_delete_idt_entry (&timer_raw_irq_data);
 } /* Timer_exit */
-
 
 /*-------------------------------------------------------------------------+
@@ -185,12 +221,8 @@
 
     atexit(Timer_exit); /* Try not to hose the system at exit. */
-
-    /* install a raw interrupt handler for timer */
-    PC386_installRawIrqHandler(TIMER_IRQ, timerisr);
-
-    /* load timer for US_PER_ISR microsecond period */
-    outport_byte(TIMER_MODE, TIMER_SEL0|TIMER_16BIT|TIMER_RATEGEN);
-    outport_byte(TIMER_CNTR0, US_TO_TICK(US_PER_ISR) >> 0 & 0xff);
-    outport_byte(TIMER_CNTR0, US_TO_TICK(US_PER_ISR) >> 8 & 0xff);
+    if (!i386_set_idt_entry (&timer_raw_irq_data)) {
+      printk("raw handler connexion failed\n");
+      rtems_fatal_error_occurred(1);
+    }
   }
   /* wait for ISR to be called at least once */
